//////////////////////////////////
//  ƓxL^vU  global.h      //
//  2015/01/23   PIC18F2523     //
//  MPLAB v8.63   C18 v3.37.01  //
//////////////////////////////////

#ifndef _GLOBAL_H
#define _GLOBAL_H

//////// CPU Type
#include <p18f2523.h>
#define CONFIG_MHZ 4

//////// ^`
typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned long ulong;

//////// main
#include <delays.h>
extern void delay_ms(uint);
extern uchar poff_cnt;

//////// Timer
#define TIMER_NUM       8
#define TIMER_MAIN_OFF  0
#define TIMER_MEASURE   1
#define TIMER_RS_WAIT   2
#define TIMER_SAMP_OFF  3
#define TIMER_ROM_READ  4
#define TIMER_TIME_SET  5
#define TIMER_WEEK_SET  6
#define TIMER_REMOVAL   7

extern volatile uint tics;
extern void timer_init(void);
extern void timer_start(int, uint);
extern void timer_restart(int, uint);
extern void timer_cancel(int);
extern int timer_check(int);
extern int timer_check_start(int);

//////// A/d
typedef union{
    int adw;
    char adb[2];
}ADDATA;
extern ADDATA addata;
extern uint ad_result[3];
extern void ad_init(void);
void ad_reserve(void);

//////// serial
extern void rs_init(void);
extern void commun(uchar);

//////// Interrupt
extern volatile uchar cnt_DOWN;
extern volatile uchar cnt_UP;
extern volatile uchar cnt_ENT;
extern volatile uchar cnt_MODE;
typedef struct {
  unsigned _DOWN:1;
  unsigned _UP:1;
  unsigned _ENT:1;
  unsigned _MODE:1;
  unsigned _DOWN_L:1;
  unsigned _UP_L:1;
  unsigned _ENT_L:1;
  unsigned _MODE_L:1;
} INSWBITS;
extern INSWBITS INSWbits;
#define DOWN        INSWbits._DOWN
#define UP          INSWbits._UP
#define ENT         INSWbits._ENT
#define MODE        INSWbits._MODE
#define DOWN_L      INSWbits._DOWN_L
#define UP_L        INSWbits._UP_L
#define ENT_L       INSWbits._ENT_L
#define MODE_L      INSWbits._MODE_L
extern volatile uchar IntI2c;
extern volatile char rxd[10];
extern volatile uchar rxp;
extern volatile uchar RXEND;

//////// LCD
#define     lcd_port    LATB
#define     lcd_stb     LATAbits.LATA5
#define     lcd_rs      LATBbits.LATB5

extern void lcd_data(char);
extern void lcd_cmd(char);
extern void lcd_clear(void);
extern void lcd_str(char *);
extern void lcd_str_rom(rom const char *);
extern void lcd_init(void);

//////// MEASURE
extern void measure(void);
extern void sampling(void);
extern void data_read(void);
extern void removal(void);
extern void read_start_time(void);
extern uchar date_buff[6];

//////// I2funk
extern void I2init(void);
extern void I2startCon(void);
extern void I2startRep(void);
extern uchar I2write(uchar);
extern uchar I2read(uchar);
extern void I2stop(void);

//////// CLOCK
extern uchar tim_data[7];
extern uchar bcd2hex(uchar);
extern uchar hex2bcd(uchar);
extern void write_ctl2(uchar);
extern uchar read_ctl2(void);
extern void read_time(void);
extern void time_dsp(void);
extern void time_set(void);
extern void alm_set(void);
extern void alm_start(void);
extern void alm_stop(void);
extern void tim_init(void);
extern void vlchk(void);
extern void show_weekdays(uchar);
extern void dig_dsp2(uchar);

#endif
