//////////////////////////////////
//  ƓxL^vU  serial.c      //
//  2015/01/23   PIC18F2523     //
//  MPLAB v8.63   C18 v3.37.01  //
//////////////////////////////////
#include "global.h"

char cmdstr1[] = {"LUX21\r"};    //MvR}hilj
char cmdstr2[] = {"LUX22\r"};    //MvR}higj
char *cmdstr;

//////// RS232C ݒ
void rs_init(void){
    TXSTA = 0x24;           //Mݒ
    RCSTA = 0x90;           //Mݒ
    SPBRG = 12;             //4MHz,19200BPS
    IPR1bits.RCIP = 1;      //M荞ݍ
    PIE1bits.RCIE = 1;      //M荞݉
}

//////// f[^PUiőM
//       FƓxf[^
void TxDataHex(uint data){
    uchar c;
    
    c = (data >> 8) & 0xf;
    if(c >= 0 && c <= 9) c = '0' + c;
    else c = 'A' + c -10;
    while(!TXSTAbits.TRMT);
    TXREG = c;                  //ʑM
    c = (data >> 4) & 0xf;
    if(c >= 0 && c <= 9) c = '0' + c;
    else c = 'A' + c -10;
    while(!TXSTAbits.TRMT);
    TXREG = c;                  //ʑM
    c = data & 0xf;
    if(c >= 0 && c <= 9) c = '0' + c;
    else c = 'A' + c -10;
    while(!TXSTAbits.TRMT);
    TXREG = c;                  //ʑM
}

//////// f[^POiőM
//       FƓxf[^
void TxDataDec(uint data){
    ulong buff;
    uchar str[8],i;

    buff = (ulong)data * 50L;
    str[0] = buff / 100000 + 0x30;
    buff = buff % 100000;
    str[1] = buff / 10000L + 0x30;
    buff = buff % 10000L;
    str[2] = buff / 1000L + 0x30;
    buff = buff % 1000L;
    str[3] = buff / 100L + 0x30;
    buff = buff % 100L;
    str[4] = buff / 10L + 0x30;
    str[5] = buff % 10L + 0x30;
    str[6] = ' ';
    str[7] = ' ';
    for(i = 0;i < 8; i++){
        while(!TXSTAbits.TRMT);
        TXREG = str[i];
    }
}

//////// PUiőM
//       Ff[^
void TxTimeHex(uchar time){
    uchar c;

    c = (time >> 4) & 0xf;
    if(c >= 0 && c <= 9) c = '0' + c;
    else c = 'A' + c -10;
    while(!TXSTAbits.TRMT);
    TXREG = c;                  //ʑM
    c = time & 0xf;
    if(c >= 0 && c <= 9) c = '0' + c;
    else c = 'A' + c -10;
    while(!TXSTAbits.TRMT);
    TXREG = c;                  //ʑM
}

//////// POiőM
void TxTimeDec(uchar time){
    uchar c;

    c = time / 10 + 0x30;
    while(!TXSTAbits.TRMT);
    TXREG = c;                  //ʑM
    time = time % 10;
    c = time + 0x30;
    while(!TXSTAbits.TRMT);
    TXREG = c;                  //ʑM
    while(!TXSTAbits.TRMT);
    TXREG = '\r';
    while(!TXSTAbits.TRMT);
    TXREG = '\n';
}

//////// Jn𑗐M
//       @1:Hex  0:Decimal
void TxTime(uchar mode){
    uchar i,buff[6];

    for(i = 0; i < 6; i++){
        buff[i] = bcd2hex(date_buff[i]);
        if(mode)TxTimeHex(buff[i]);
        else TxTimeDec(buff[i]);
    }
}

///////// Cԍ𑗐M
//        @Cԍ
void tx_head(uint lx){
    uchar str[5],c1,c2,c3,i;

    c1 = lx / 100;
    lx = lx % 100;
    c2 = lx / 10;
    c3 = lx % 10;
    str[0] = c1 + 0x30;
    str[1] = c2 + 0x30;
    str[2] = c3 + 0x30;
    str[3] = ' ';
    str[4] = ' ';
    for(i = 0;i < 5;i++){
        while(!TXSTAbits.TRMT);
        TXREG = str[i];
    }
}

//////// f[^M
//       @1:Hex  0:Decimal
void data_send(uchar form){
    uint i, addr;
    uint buff[4];
    uchar j;
    
     lcd_clear();
     lcd_cmd(0x80);
     lcd_str_rom("");
     for(i = 0;i < 840; i++){
        IntI2c = 0;
        addr =i * 4;
        I2startCon();               //X^[gRfBV
        I2write(0xae);              //foCXZNgiCgj
        I2write(addr >> 8);         //AhXʏ
        I2write(addr);              //
        I2startRep();               //X^[gđ
        I2write(0xaf);              //foCXZNgi[hj
        for(j = 0; j < 3; j++){     //ROMf[^ǂݎ
            buff[j] = I2read(0);
        }
        buff[3] = I2read(1);
        I2stop();
        if(form){
            TxDataHex((buff[0] << 8) + buff[1]);
            TxDataHex((buff[2] << 8) + buff[3]);
        }
        else{
            tx_head(i + 1);
            TxDataDec((buff[0] << 8) + buff[1]);
            TxDataDec((buff[2] << 8) + buff[3]);
            while(!TXSTAbits.TRMT);
            TXREG = '\r';
            while(!TXSTAbits.TRMT);
            TXREG = '\n';
        }
    }
    read_start_time();                  //JnԂǂݎ
    TxTime(form);                       //M
    if(form){
        while(!TXSTAbits.TRMT);
        TXREG = '\r';
        while(!TXSTAbits.TRMT);
        TXREG = '\n';
    }
}

//////// qnlf[^obɑM
//         1:wLT  0:POi
void commun(uchar hd){
    uchar i,j,count;

    count = 0;
    LATAbits.LATA4 = 0;                  //qrdI
    TRISC =  0xbf;                       //qbUo̓|[g
    rs_init();                           //RS232C ݒ
    timer_start(TIMER_RS_WAIT,60000);    //LZp
job_start:  ;
    lcd_clear();
    while(1){
        lcd_cmd(0x80);
        lcd_str_rom("RS232C  ");
        RXEND = 0;
        rxp = 0;
        for(j = 0; j < 10; j++) rxd[i] = ' ';   //Mobt@
        while(1){
            if(MODE) goto job_end;
            if(RXEND) goto job_next;
            if(timer_check_start(TIMER_RS_WAIT)) count++;
            if(count > 5) goto job_end;
        }
   }
job_next:   ;
    if(hd) cmdstr = cmdstr2;
    else cmdstr = cmdstr1;
    for(i = 0; i < 6; i++){
        if(cmdstr[i] != rxd[i]){                    //eႤ
            lcd_cmd(0xc0);
            lcd_str_rom("޴װ");
            delay_ms(3000);
            lcd_cmd(0xc0);
            lcd_str_rom("        ");
            rxp = 0;
            for(j = 0; j < 10; j++) rxd[i] = ' ';   //Mobt@
            RXEND = 0;
            goto job_start;
        }
    }
    data_send(hd);
job_end: ;
    timer_cancel(TIMER_RS_WAIT);
    TXSTAbits.TXEN = 0;             //M֎~
    TRISC = 0xff;                   //qbU̓|[g
    LATAbits.LATA4 = 1;             //qrdIt
}
