//////////////////////////////////
//  ƓxL^vU  timer.c       //
//  2015/01/23   PIC18F2523     //
//  MPLAB v8.63   C18 v3.37.01  //
//////////////////////////////////
#include "global.h"

static uint set_time[TIMER_NUM];    //^C}[ݒl
static uint start_time[TIMER_NUM];  //Jn̒l
volatile uint tics;                 //^C}[pJEgl

//////// TIMER1ACCP1 ݒ
void timer_init(void){
    int n;

    T1CON = 0x81;                   //Timer1 16bit,ps1/1,enable
    TMR1H = 0;                      //Timer1 clear
    TMR1L = 0;
    PIE1bits.TMR1IE = 0;            //Timer1 荞݋֎~
    CCP1CON = 0xb;                  //Special Event
    CCPR1H = 0x3;                   //1u x 1000
    CCPR1L = 0xe8;
    IPR1bits.CCP1IP = 1;            //荞ݗD惌xʑɂĂ
    PIE1bits.CCP1IE = 1;            //bbo荞݋
    for(n = 0; n < TIMER_NUM; n++) set_time[n] = 0;
}

//////// ^C}[Jn
//       @^C}[ԍA
void timer_start(int num, uint time){
    if(set_time[num]) return;
    set_time[num] = time;
    start_time[num] = tics;
}

//////// ^C}[ċN
//       @^C}[ԍA
void timer_restart(int num, uint time){
    set_time[num] = time;
    start_time[num] = tics;
}

//////// ^C}[~
//       @^C}[ԍ
void timer_cancel(int num){
    set_time[num] = 0;
}

//////// ^CAbṽ`FbN
//       @^C}[ԍ
int timer_check(int num){
    if (!set_time[num]) return 0;
    if (tics - start_time[num] < set_time[num]) return 0;
    set_time[num] = 0;
    return 1;
}

//////// ^CAbvċN
//       @^C}[ԍ
int timer_check_start(int num){
    if (!set_time[num]) return 0;
    if (tics - start_time[num] < set_time[num]) return 0;
    start_time[num] = tics;
    return 1;
}
